{{- $cpnt := .Values.apiserver }}
apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ $cpnt.component }}
  labels:
    {{- include "portal.labels" . | nindent 4 }}
spec:
  {{- if not .Values.autoscaling.enabled }}
  replicas: {{ .Values.replicaCount }}
  {{- end }}
  selector:
    matchLabels:
      {{- include "portal.selectorLabels" . | nindent 6 }}
      {{- include "portal.componentLabels" $cpnt | nindent 6 }}
  template:
    metadata:
      labels:
        {{- include "portal.selectorLabels" . | nindent 8 }}
        {{- include "portal.componentLabels" .Values.apiserver | nindent 8 }}
    spec:
      serviceAccountName: {{ include "portal.serviceAccountName" . }}
      containers:
        - name: {{ $cpnt.component }}
          image: {{ .Values.image.repository }}/{{ $cpnt.repository_path }}:{{- .Values.image.tag | default .AppVersion }}
          imagePullPolicy: {{ .Values.image.pullPolicy | default "IfNotPresent" }}
          env:
            {{- include "portal.Env" . | nindent 12 }}
            {{- include "portal.namespacesEnv" . | nindent 12 }}
            {{- include "portal.minioEnv" . | nindent 12 }}
            {{- include "portal.artifact_minioEnv" . | nindent 12 }}
            - name: PORTAL_FROM_EMAIL_ADDR
              value: {{ .Values.communications.portalEMailFrom | quote }}
            - name: PORTAL_OPS
              value: {{ .Values.opsId | quote | required "opsId must be set" }}
          command: 
            - /usr/bin/apiserver
            - -api
            - {{ $cpnt.ingress.api.endpoint }}:443
            - -grpc
            - {{ $cpnt.ingress.grpc.endpoint }}:443
            - -ssh
            - {{ .Values.sshJump.fqdn }}:{{ .Values.sshJump.service.sshPort }}
            - -origins
            - {{ $cpnt.ingress.api.allowedOrigins }}
          ports:
            - name: grpc
              containerPort: 6000
              protocol: TCP
            - name: rest
              containerPort: 8081
              protocol: TCP
          volumeMounts:
            - mountPath: /etc/merge
              name: policy-volume
            - mountPath: /etc/merge/hooks
              name: hooks-volume
          # TODO: support for /health
          # livenessProbe:
          #   httpGet:
          #     path: /health
          #     port: 8081
          # readinessProbe:
          #   httpGet:
          #     path: /health
          #     port: 8081
      {{- with .Values.serviceTolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      volumes:
        - name: policy-volume
          configMap:
            defaultMode: 420
            name: policy
        - name: hooks-volume
          configMap:
            defaultMode: 420
            name: hooks
